#INCLUDE "efrx_xfrx.h"
#INCLUDE "../prgs/main.h"

*******************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_EFRX_XFRX",lcCollate)

****************************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_EFRX_XFRX_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_EFRX_XFRX_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)

****************************************************************************
DEFINE CLASS _EFRX_XFRX AS _pdm_PlugIn && 
   Name="_EFRX_XFRX"

   ID=100         && ID of Plug-in
   Type="EFRX" && 

   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         SELE (This.ALTab)
         SET ORDER TO "I01"
         llEn=.F.
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "XFRX")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetCSS, "CSS File")
         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC


   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,loPDM,lii,liCount,lcHTML,lix,;
            llSingle,lcComment,lcRow,liz,lcURName,lcUROutline,lcUROutlineStyle,;
            lcURHREF,llExtract,liy,lix,lcURRotate, lcURIncludeFont,lcAHREF,lcPom,lcPom2,;
            lcURColor,lcURMask,lcURXLSF,lcURPA

      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)
      
      STORE "" TO lcHTML,lcURName,lcUROutline,lcURHREF,lcURRotate,lcURINCLUDEFONT,lcURToolTip,;
                  lcUROutlineStyle,lcURColor,lcURMask,lcURXLSF,lcURPA

      lcComment=loPar.Ram.COMMENT

      * #UR A HREF=<destination name> - zdroj dat pro fiktivn objekt
      * #UR A HREF="#top"             - zatek dokumentu
      * #UR A HREF="#custlist"        - Sko na pole jeho jmno je ...
      * #UR A HREF="#"+customer.id    - Sko na pole jeho hodnota je ...
      * #UR A HREF="http://www.eqeus.com" - Sko na strnku (co ftp:// gopher:// a file:// mailto://)
      * #UR A NAME=<destination name> - Oznaen clovho pole
      * #UR TOOLTIP=<expr>            - tooltiptext
      * #UR OUTLINE=<outline_name>    - pznak pole do stromu (PDF)
      * #UR OUTLINESTYLE=0            - Styl B/I/U text pro outline
      * #UR ROTATE=45                 - Otoen o stup(PDF)
      * #UR INCLUDEFONT=SUBSET        - Pznak, zda se m vloit font danho objektu do PDF

      * NEW
      * #UR XLSF="General"            - The "General" formatting - no special formatting, the number of decimal places is determined by the field's value
      * #UR XLSF="Text"               - 
      * #UR XLSF="Standard"           - The "Standard" formatting - two decimal places, thousand and decimal separators will be used according to the Excel default
      * #UR XLSF="#0.00" (aany format)- 

      * #UR POSITIONABSOLUTE

      
      liCount=ALINES(laRows,lcComment)
      lcComment=""
      FOR lii=1 TO liCount
          lcRow=LTRIM(laRows(lii))

          liz=AT_NonSpace(@lcRow,1) && najdi prvn znak
          liz=IIF(liz=0,1,liz)

          llExtract=.F.
          DO CASE
             CASE UPPER(SUBST(lcRow,liz,10))=="#UR A HREF"
                  IF LEN(lcURHREF)=0
                     liy=AT_Ex(@lcRow,"=",liz+10) && Najdi =
                     liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak

                     IF liy>0
                        IF SUBST(lcRow,liy+1,1)="#" && skoky uvnit dokumentu
                           liz=AT_Ex(@lcRow,'"',liy+2) && Najdi "
                   
                           IF liz>0
                              lix=AT_Ex(@lcRow,'+',liz+1) && Najdi +
                      
                              IF lix>0
                                 lcPom=SUBS(lcRow,lix+1)
                                 lcPom2=loPDM.FRX.GetObjLinkByName(lcPom)

                                 lcURHREF=IIF(LEN(lcPom2)>0,[<a href="]+lcPom2+[" target="F31">],"")+loPDMs.SC_Expr+'>'+;
                                          IIF(loPDM.SyntaxColoring=0,StrTranHTMLString(lcPom),;
                                          loPDMs.HTML.PRGToHTML(@lcPom,loPDMs.SCRam,"0"))+;
                                          loPDMs.SC_Expr_Close+IIF(LEN(lcPom2)>0,[</a>],"")+m.loPDM.aSpace(21)
                              ELSE
                                 * Skok na pole
                                 lcURHREF=SUBS(lcRow,liy+2,liz-liy-2)
                              ENDIF
                           ENDIF
                        ELSE
                           lix=AT_Ex(@lcRow,':',liy+2)
                           IF lix>0
                              lcAHREF=UPPER(SUBSTR(lcRow,liy+1,lix-liy))
                              IF lcAHREF=="HTTP:" OR lcAHREF=="HTTPS:" OR lcAHREF=="FILE:" OR;
                                 lcAHREF=="FTP:" OR lcAHREF=="GOPHER:" OR;
                                 lcAHREF=="MAILTO:" OR lcAHREF=="NEWS:" OR lcAHREF=="TELNET:" OR;
                                 lcAHREF=="WAIS:"
                                 liz=AT_Ex(@lcRow,'"',lix+1) && Najdi "
                                 lcURHREF=[<a href="]+SUBST(lcRow,liy+1)+[">]+SUBST(lcRow,liy+1,liz-liy-1)+[</a>]
                              ENDIF
                           ENDIF
                        ENDIF
                        llExtract=.T.
                     ENDIF
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,10))=="#UR A NAME"
                  IF LEN(lcURName)=0
                     liy=AT_Ex(@lcRow,"=",liz+10) && Najdi =
                     liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak
                     IF liy>0
                        lcURName=SUBST(lcRow,liy)
                        llExtract=.T.
                     ENDIF
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,16))=="#UR OUTLINESTYLE"
                  IF LEN(lcUROutlineStyle)=0
                     liy=AT_Ex(@lcRow,"=",liz+10) && Najdi =
                     liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak
                     IF liy>0
                        lcUROutlineStyle=SUBST(lcRow,liy)
                        llExtract=.T.
                     ENDIF
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,11))=="#UR OUTLINE"
                  IF LEN(lcUROutline)=0
                     liy=AT_Ex(@lcRow,"=",liz+10) && Najdi =
                     liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak
                     IF liy>0
                        lcUROutline=SUBST(lcRow,liy)
                        llExtract=.T.
                     ENDIF
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,10))=="#UR ROTATE"
                  IF LEN(lcURRotate)=0
                     liy=AT_NonSpace(@lcRow,liz+10) && Najdi hodnotu
                     IF liy>0
                        lcURRotate=SUBST(lcRow,liy)+"%"
                        llExtract=.T.
                     ENDIF
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,15))=="#UR INCLUDEFONT"
                  llExtract=.T.
                  IF LEN(lcURIncludeFont)=0
                     liy=AT_NonSpace(@lcRow,liz+15) && Najdi hodnotu
                     lcURIncludeFont=IIF(liy>0 AND SUBST(lcRow,liy,6)=="SUBSET","Include subset","Include")
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,11))=="#UR TOOLTIP"
                  IF LEN(lcURToolTip)=0
                     liy=AT_Ex(@lcRow,"=",liz+10) && Najdi =
                     liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak
                     IF liy>0
                        lcPom=SUBST(lcRow,liy)

                        lcURToolTip=loPDMs.SC_Expr+'>'+;
                                    IIF(loPDM.SyntaxColoring=0,StrTranHTMLString(lcPom),;
                                    loPDMs.HTML.PRGToHTML(@lcPom,loPDMs.SCRam,"0"))+;
                                    loPDMs.SC_Expr_Close+m.loPDM.aSpace(21)

                        llExtract=.T.
                     ENDIF
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,9))=="#UR COLOR"
                  IF LEN(lcURColor)=0
                     liy=AT_NonSpace(@lcRow,liz+9) && najdi prvn znak
                     IF liy>0
                        lcURColor=SUBST(lcRow,liy)
                        llExtract=.T.
                     ENDIF
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,8))=="#UR MASK"
                  IF LEN(lcURMask)=0
                     liy=AT_NonSpace(@lcRow,liz+8) && najdi prvn znak
                     IF liy>0
                        lcURMask=SUBST(lcRow,liy)
                        llExtract=.T.
                     ENDIF
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,8))=="#UR XLSF"
                  IF LEN(lcURXLSF)=0
                     liy=AT_Ex(@lcRow,"=",liz+10) && Najdi =
                     liy=IIF(liy>0,AT_NonSpace(@lcRow,liy+1),0) && najdi prvn znak
                     IF liy>0
                        lcURXLSF=ALLT(SUBST(lcRow,liy))
                        lcURXLSF=SUBST(lcURXLSF,1,LEN(lcURXLSF)-2)

                        lcURXLSF=IIF(lcURXLSF="General" OR lcURXLSF="Standard" OR lcURXLSF="Text",lcXLSF,;
                                  loPDMs.SC_Expr+'>'+;
                                  IIF(loPDM.SyntaxColoring=0,StrTranHTMLString(lcURXLSF),;
                                  loPDMs.HTML.PRGToHTML(@lcURXLSF,loPDMs.SCRam,"0"))+;
                                  loPDMs.SC_Expr_Close)+m.loPDM.aSpace(21)
                        llExtract=.T.
                     ENDIF
                  ELSE
                     llExtract=.T.
                  ENDIF

             CASE UPPER(SUBST(lcRow,liz,20))=="#UR POSITIONABSOLUTE"
                  IF LEN(lcURPA)=0
                     lcURPA="Y"
                     llExtract=.T.
                  ELSE
                     llExtract=.T.
                  ENDIF

          ENDCASE

          IF !llExtract
             lcComment=lcComment+lcRow+CRLF
          ENDIF
      NEXT

      IF LEN(lcURHREF)>0 OR LEN(lcURName)>0 OR LEN(lcUROutline)>0 OR ;
         LEN(lcURRotate)>0 OR LEN(lcURIncludeFont)>0 OR LEN(lcURToolTip)>0 OR ;
         LEN(lcUROutlineStyle)>0 OR LEN(lcURColor)>0 OR LEN(lcURMask)>0 OR LEN(lcURXLSF)>0 OR;
         LEN(lcURPA)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(1)+[<table><tbody>]+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURHREF)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_xfrx_td_bold">]+This.GetHTMLString(PI_HTML_Hyperlink)+[</td><td>]+lcURHREF+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURName)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_xfrx_td_bold">]+This.GetHTMLString(PI_HTML_Bookmark)+[</td><td>]+lcURName+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcUROutline)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_xfrx_td_bold">]+This.GetHTMLString(PI_HTML_Outline)+[</td><td>]+lcUROutline+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF
      IF LEN(lcUROutlineStyle)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_xfrx_td_bold">]+This.GetHTMLString(PI_HTML_OutlineS)+[</td><td>]+lcUROutline+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURRotate)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_xfrx_td_bold">]+This.GetHTMLString(PI_HTML_Rotate)+[</td><td>]+lcURRotate+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURIncludeFont)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_xfrx_td_bold">]+This.GetHTMLString(PI_HTML_EFont)+[</td><td>]+lcURIncludeFont+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURToolTip)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_xfrx_td_bold">]+This.GetHTMLString(PI_HTML_TTT)+[</td><td>]+lcURToolTip+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURColor)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_xfrx_td_bold">]+This.GetHTMLString(PI_HTML_Color)+[</td><td>]+lcURColor+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURMask)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_xfrx_td_bold">]+This.GetHTMLString(PI_HTML_Mask)+[</td><td>]+lcURMask+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURXLSF)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_xfrx_td_bold">]+This.GetHTMLString(PI_HTML_XLSF)+[</td><td>]+lcURXLSF+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURPA)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_xfrx_td_bold">]+This.GetHTMLString(PI_HTML_PA)+[</td><td>]+This.GetHTMLString(PI_HTML_Yes)+"</td></tr>"+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURHREF)>0 OR LEN(lcURName)>0 OR LEN(lcUROutline)>0 OR ;
         LEN(lcURRotate)>0 OR LEN(lcURIncludeFont)>0 OR LEN(lcURToolTip)>0 OR ;
         LEN(lcUROutlineStyle)>0 OR LEN(lcURColor)>0 OR LEN(lcURMask)>0 OR LEN(lcURXLSF)>0 OR;
         LEN(lcURPA)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(1)+[</tbody></table>]+m.loPDM.aSpace(21)
      ENDIF


      IF LEN(lcHTML)>0
         lcHTML=m.loPDM.aSpace(1)+"<hr>"+m.loPDM.aSpace(21)+lcHTML
      ENDIF

      loPar.Ram.COMMENT=lcComment

      RETURN lcHTML
   ENDPROC

   PROCEDURE GetSetting()
      RETURN CREATEOBJECT("_EFRX_XFRX_par")
   ENDPROC

   * Nate nastaven
   PROCEDURE Open(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      loSettings.CSS=GetINIString(lcSection,"CSS",loSettings.CSS,254,@lcFile)
      loSettings.JS=GetINIString(lcSection,"JS",loSettings.JS,254,@lcFile)

      RETURN _PDM_OK
   ENDPROC

   * Ulo nastaven
   PROCEDURE Save(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      =WriteINIString(lcSection,"CSS",ALLT(loSettings.CSS),@lcFile)
      =WriteINIString(lcSection,"JS",ALLT(loSettings.JS),@lcFile)
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst)
      * loSrc - Source object
      * loDst - Destination object
      loDst.CSS=loSrc.CSS
      loDst.JS=loSrc.JS
   ENDPROC

   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      LOCAL loPDMs,lcLang,lcPath,lcFile,llEn
      loPDMs=EVAL(This.PDMs)
      lcLang=loPDMs.HTMLCLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Open table with HTML's string
      IF !USED(This.AHTML)
         llEn=.T.
         IF !lcLang=="en" AND ;
            loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\HTML_"+lcLang+".dbf",This.AHTML,"NOUPDATE")=0
            SELE (This.AHTML)
            SET ORDER TO "I01"
            llEn=.F.
         ENDIF

         IF llEn
            CREATE CURSOR (This.AHTML) (XX000 I, XX001 M)
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Hyperlink, "Hyperlink:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Outline, "Outline:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Bookmark, "Bookmark:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_OutlineS, "Outline Style:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Rotate, "Rotate:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_EFont, "Embeded font:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_TTT, "ToolTipText:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Color, "Color:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Mask, "Mask:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_XSLF, "XSL Format:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_PA, "Position absolute:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Yes, "Yes")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_No, "No")
            SELE (This.AHTML)
            INDEX ON XX000 TAG I01
         ENDIF
      ENDIF
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources()
      RETURN .T.
   ENDPROC

ENDDEFINE

***********************************************************
DEFINE CLASS _EFRX_XFRX_par AS custom
   Name="_EFRX_XFRX_par"
   OK=.F.
 
   CSS="efrx_xfrx.css" && Relative to efrx_xfrx.fxp
   JS="" && 

   _CSS="" && Relative to ....
   _JS="" && 

ENDDEFINE
